//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : BUZZER
// BOARD    : ZL15AVR (with ATmega32 in socket U1)
// COMPILER : WinAVR 20080610
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple sound generating.
//
//    Settings and connections on ZL15AVR:
//        PA0 (con15) - SPK (con7)
//
//******************************************************************************
#ifndef F_CPU  
  #define F_CPU   16000000    // 16 MHz - turn on external resonator (fuse bits)
#endif

#include <avr/io.h>
#include <util/delay.h>
//-------------------------------------
// Sound function
//-------------------------------------
void Sound(int duration, int pulses)
{
volatile int i;
while(duration--)
  {
  for(i = pulses ; i > 0; i--);
  PORTA ^= (1 << PA0);
  }
}
//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
char i;
DDRA |= (1 << PA0); // Config port
// Infinite loop
do{
  Sound(1000,400);			// play sound
  for(i = 0; i < 200; i++)	// Wait 2 seconds
    _delay_ms(10);			//
}while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
