//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : CHAR LCD
// BOARD    : ZL15AVR (with ATmega32 in socket U1)
// COMPILER : WinAVR 20080610
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Using LCD character display (HD44780 compatible) in 4-bit mode.
//
//    Settings and connections on ZL15AVR:
//        JP4 (DISPLAY) - 2-3 (=CHAR)
//
//        D4 (LCD_CHAR/con13) - PD4 (con18)
//        D5 (LCD_CHAR/con13) - PD5 (con18)
//        D6 (LCD_CHAR/con13) - PD6 (con18)
//        D7 (LCD_CHAR/con13) - PD7 (con18)
//        E  (LCD_CHAR/con13) - PB2 (con16)
//        RS (LCD_CHAR/con13) - PB0 (con16)
//        RW (LCD_CHAR/con13) - GND (con15)
//
//
//******************************************************************************
#ifndef F_CPU  
  #define F_CPU   16000000    // 16 MHz - turn on external resonator (fuse bits)
#endif

#include <avr/io.h>
#include <util/delay.h>
#include "HD44780.h"
//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
char temp, i;
LCD_Initialize();

LCD_GoTo(0,0);
LCD_WriteText(" -- ZL15AVR -- ZL15AVR --");
LCD_GoTo(0,1);
LCD_WriteText(" Kamami Development Board");

do{
for(temp = 0; temp < 10; temp++) // shift the text to the left
  {
  LCD_ShiftLeft();
  for(i= 0; i < 40; i++)	// wait 400 ms
    _delay_ms(10);
  }
for(temp = 0; temp < 10; temp++) // shift the text to the right 
  {
  LCD_ShiftRight();
  for(i= 0; i < 40; i++)	// wait 400 ms
    _delay_ms(10);
  }
}while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
