//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : CHAR LCD
// BOARD    : ZL15AVR (with ATmega32 in socket U1)
// COMPILER : WinAVR 20080610
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Using LCD graphic display (KS0108 compatible)
//
//    Settings and connections on ZL15AVR:
//        JP4 (DISPLAY) - 1-2 (=GRAPH)
//
//        D0 (LCD_GRAPH/con12) - PA0 (con15)
//        D1 (LCD_GRAPH/con12) - PA1 (con15)
//        D2 (LCD_GRAPH/con12) - PA2 (con15)
//        D3 (LCD_GRAPH/con12) - PA3 (con15)
//        D4 (LCD_GRAPH/con12) - PA4 (con15)
//        D5 (LCD_GRAPH/con12) - PA5 (con15)
//        D6 (LCD_GRAPH/con12) - PA6 (con15)
//        D7 (LCD_GRAPH/con12) - PA7 (con15)
//
//        RS (LCD_GRAPH/con12) - PC0 (con17)
//        RW (LCD_GRAPH/con12) - PC1 (con17)
//        E  (LCD_GRAPH/con12) - PC2 (con17)
//        CS1(LCD_GRAPH/con12) - PC4 (con17)
//        CS2(LCD_GRAPH/con12) - PC3 (con17)
//
//******************************************************************************
#ifndef F_CPU  
  #define F_CPU   16000000    // 16 MHz - turn on external resonator (fuse bits)
#endif

#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include "KS0108.h"
#include "kamami.h"

//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
int i;

GLCD_Initialize();  							// LCD initialization

do{
GLCD_ClearScreen(); 							// clear screen

GLCD_WriteStringXY("   K A M A M I",12,0);		//
GLCD_WriteStringXY("development board",12,1);	// display text
GLCD_WriteStringXY(" -- ZL15AVR --  ",12,3);	//
GLCD_WriteStringXY(" www.kamami.com ",12,4);	//

for(i = 0; i < 200; i++)						// wait2 seconds
  _delay_ms(10);								// 

GLCD_Bitmap(kamami,0,0,128,64);					// display picture

for(i = 0; i < 200; i++)						// wait 2 seconds
  _delay_ms(10);								// 

}while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
