//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : RC5
// BOARD    : ZL15AVR (with ATmega32 in socket U1)
// COMPILER : WinAVR 20080610
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple infrared RC5 code receiver
//
//    Settings and connections on ZL15AVR:
//        IR (con7) - PD2 (con18)
//
//      if RS232 cable connected:
//        RxD (con7) - PD0 (con18)
//        TxD (con7) - PD1 (con18)
//
//      if UART2USB converter (ZL1USB_A or ZL4USB) connected:
//        RxU (con7) - PD0 (con18)
//        TxU (con7) - PD1 (con18)
//
//******************************************************************************
#ifndef F_CPU  
  #define F_CPU   16000000    // 16 MHz - turn on external resonator (fuse bits)
#endif

#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include "USART.h"
#include "RC5.h"
}
//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
char str [5];

char RC5Address=0, RC5Command=0;

USART_Init(BAUD(1200));

RC5_Init();

USART_PutString("*************************\r");
USART_PutString("**    ZL15AVR IR RC5   **\r");
USART_PutString("**    www.kamami.com   **\r");
USART_PutString("*************************\r");

USART_PutString("Waiting for RC5...\r");

do{
  GetRC5(&RC5Address, &RC5Command);
  USART_PutString("Address (hex): ");
  USART_PutString(Hex(RC5Address, str));
  USART_PutString(" Command (hex): ");
  USART_PutString(Hex(RC5Command, str));
  USART_PutChar('\r');
}while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
