//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
#include <avr/interrupt.h>

#define CYCLESPERUS	(F_CPU/1000000)
#define PRESCALE	8
#define TICKSPERUS(x) ((x*CYCLESPERUS)/PRESCALE)
#define TIMERVALUE(x) (65535-(TICKSPERUS(x)))

volatile unsigned char Cmd, CmdN, Adr, AdrN;
volatile unsigned char RC5Counter, RC5Status;

#define RC5PIN PIND
#define RC5IN  PD2
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void GetRC5(char * Address, char * Command)
{
while((RC5Status & 1)==0);
RC5Status = 0;
*Address = Adr;
*Command = Cmd;
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void RC5_Init(void)
{
  GIMSK = 0x40;
  MCUCR = 0x02;
  sei();
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
ISR(INT0_vect)
{
Cmd=CmdN=Adr=AdrN = 0;
RC5Counter = 0;
RC5Status = 0;

TCNT1H = (char) (TIMERVALUE(443) >> 8);
TCNT1L = (char) TIMERVALUE(443);
TCCR1B = (1 << CS11);
TIMSK |= (1 << TOIE1);
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
ISR(TIMER1_OVF_vect)
{
TCNT1H = (char) (TIMERVALUE(883) >> 8);
TCNT1L = (char) TIMERVALUE(883);

GIMSK &= 0b10111111;

RC5Counter++;

if(RC5Counter == 1)
  return;

if((RC5Counter < 28)&&(RC5Counter < 16))
  {
  if((RC5Counter&1)==0)
    {
    Adr <<= 1;
    if(RC5PIN & (1 << RC5IN))
      Adr |= 1;
    }
  else
    {
    AdrN <<= 1;
    if(!(RC5PIN& (1 << RC5IN)))
      AdrN |= 1;
    }
  }
else
if((RC5Counter < 28)&&(RC5Counter >= 16))
  {
  if((RC5Counter&1)==0)
    {
    Cmd <<= 1;
    if(RC5PIN & (1 << RC5IN))
      Cmd |= 1;
    }
  else
    {
    CmdN <<= 1;
    if(!(RC5PIN & (1 << RC5IN)))
      CmdN |= 1;
    }
  }
else
if(RC5Counter == 28)
  {
  TCCR1B = 0;
  RC5Counter = 0;

  GIFR |= 0x40;
  
  GIMSK |= 0x40;

  if(Cmd != CmdN)
    return;
  if(Adr != AdrN)
    return;

  Adr &= 0x1F;
  Cmd &= 0x3F;

  RC5Status |= 1;

  }
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
